<?php

	/* Usage
	$exfl = new exfilelock( array(
		'dir'      => './lockdir/',			// ロックファイル格納ディレクトリ名。(後ろにスラッシュつけること)
		'basename' => 'lockfile',				// ロックファイル名
		'timeout'  => 60 ,							// タイムアウト（sec）
		'trytime'  => 10 ,							// トライ回数
	) );
	$exfl->flock() or die('Busy!');
	$exfl->unflock() or die('Busy!');
	*/


class exfilelock
{
	var $option = array();

	//================== コンストラクタ
	function __construct( $options=array() ){
		$this->option = array_merge(array(
			'dir'      => './lockdir/',
			'basename' => 'lockfile',
			'timeout'  => 60,
			'trytime'  => 10), $options);
		$this->option['path'] = $this->option['dir'] . $this->option['basename'];
	}



	//================== flock
	public function flock(){
	    for ($i = 0; $i < $this->option['trytime']; $i++, sleep(1)) {
	        if ( @rename($this->option['path'], $this->option['current'] = $this->option['path'] . time()) ) {
	            return $this->option;
	        }
	    }
	    $filelist = $this->_scandir($this->option['dir']);
	    foreach ($filelist as $file) {
	        if (preg_match('/^' . $this->option['basename'] . '(\d+)/', $file, $matches)) {
	            if (time() - $matches[1] > $this->option['timeout']
	              and rename($this->option['dir'] . $matches[0],
	                         $this->option['current'] = $this->option['path'] . time())
	            ) {
	                return $this->option;
	            }
	            break;
	        }
	    }
	    return false;
	}



	//================== unflock
	public function unflock() {
	    return rename($this->option['current'], $this->option['path']);
	}



	//================== _scandir
	private function _scandir($dir) {
	    $dh  = opendir($dir);
	    $files = array();
	    while (false !== ($filename = readdir($dh))) {
	        $files[] = $filename;
	    }
	    return $files;
	}



}
